/*=========================================================================

  Program:   Insight Segmentation & Registration Toolkit
  Module:    $RCSfile: $
  Language:  C++
  Date:      $Date: $
  Version:   $Revision: $
  Author:    Gavin Baker <gavinb@cs.mu.oz.au>

  Copyright 2004 (c) Insight Software Consortium. All rights reserved.
  See ITKCopyright.txt or http://www.itk.org/HTML/Copyright.htm for details.

     This software is distributed WITHOUT ANY WARRANTY; without even 
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
     PURPOSE.  See the above copyright notices for more information.

=========================================================================*/

#include "itkAdditiveGaussianNoiseImageFilter.h"

namespace itk
{

template <class TInputImage>
AdditiveGaussianNoiseImageFilter<TInputImage>
::AdditiveGaussianNoiseImageFilter()
{
    m_NoiseFilter = NoiseFilterType::New();
}

/*
template <class TInputImage>
AdditiveGaussianNoiseImageFilter::GenerateOutputInformation()
{
    Superclass::GenerateOutputInformation();

}
*/

template <class TInputImage>
void
AdditiveGaussianNoiseImageFilter<TInputImage>
::GenerateData()
{
    //itkDebugMacro(<< "+++ Noisy::GenerateData()");

    this->AllocateOutputs();

    // Setup grafted pipeline for composite

    m_NoiseFilter->SetInput( this->GetInput() );
    this->GraftOutput( m_NoiseFilter->GetOutput() );

    //itkDebugMacro(<< "--- Noisy::GenerateData()");
}

template <class TInputImage>
void
AdditiveGaussianNoiseImageFilter<TInputImage>
::PrintSelf(std::ostream& os,
            Indent indent) const
{
    os
        << "AdditiveGaussianNoiseImageFilter: sigma="
        << GetAlpha()
        << std::endl;
}

} /* namespace itk */
